%Disparity estimation test

addpath ./lib/qtfm/

clear all;

n=128;
u=-n/2:n/2-1;
%u=1:n;
v=u;
eps1=0.0005;
r=[(n/2)/20,(n/2)/5]; %length of sides of rect
c1=[(n/2)/3,(n/2)/2];  %center or rect
c2=[(n/2)/3+1,(n/2)/2+1];%center or rect
c3=[n/-8,n/-8];%center or rect

[U,V]=meshgrid(u,v);
 
R1=abs(U-c1(1)) < r(1);
R2=abs(V-c1(2)) < r(2);
Ra=real(min(R1,R2));

%Raft=fft2(Ra);

R3=abs(U-c2(1)) < r(1);
R4=abs(V-c2(2)) < r(2);
%R5=abs(U-c3(1)) < r1(1);
%R6=abs(V-c3(2)) < r1(2);
Rb=real(min(R3,R4));
%Rc=real(min(R5,R6));
Rb=Rb;%+Rc;

clear r r1 c1 c2 c3;
clear R1 R2 R3 R4 R5 R6 Rc;


Rbft=fft2(Rb);
Raft=fft2(Ra);


za=zeros(size(Ra,1),size(Ra,2));
zb=zeros(size(Rb,1),size(Rb,2));

qRa=quaternion(Ra,za,za,za);
qRb=quaternion(Rb,zb,zb,zb);
qRaft=qfft2(qRa);
qRbft=qfft2(qRb);




%Construct Quaternion Gabor Filer
%gausian
eps=1;
sigma1=var(fft(Ra,[],1));
sigma2=var(fft(Ra,[],2));
sigma3=0;
sigma4=0;
for i=1:n
    sigma3 = sigma3 + sigma1(1,i);
    sigma4 = sigma4 + sigma2(1,i);
end
%sigma=sqrt((sigma3/n)*(sigma4/n))
sigma=.5*sqrt((sigma3/n)^2+(sigma4/n)^2);
%sigma=.05
clear sigma1 sigma2 sigma3 sigma4;
%N=eps./(2*pi*sigma^2);
sigma=3;
g=(exp(-(U.^2+(eps*V).^2)/(sigma^2)));

%finding u0 and v0
f1=fft(Ra,[],1);
u0=max(max(real(f1)));
f2=fft(Ra,[],2);
v0=max(max(real(f2)));
clear f1 f2;

%quaternion component
w1=.5.*U;
w2=.5.*V;
%Components of QGF and ffts of components
hee=g.*(cos(w1).*cos(w2));
fthee=fft2(hee);
hoe=g.*(sin(w1).*cos(w2));
fthoe=fft2(hoe);
heo=g.*(cos(w1).*sin(w2));
ftheo=fft2(heo);
hoo=g.*(sin(w1).*sin(w2));
fthoo=fft2(hoo);


clear w1 w2;

%convolve filter with image a
ftkeea=fthee.*Raft;
keea=ifft2(ftkeea);
ftkoea=fthoe.*Raft;
koea=ifft2(ftkoea);
ftkeoa=ftheo.*Raft;
keoa=ifft2(ftkeoa);
ftkooa=fthoo.*Raft;
kooa=ifft2(ftkooa);

%convolve filter with image b
ftkeeb=fthee.*Rbft;
keeb=ifft2(ftkeeb);
ftkoeb=fthoe.*Rbft;
koeb=ifft2(ftkoeb);
ftkeob=ftheo.*Rbft;
keob=ifft2(ftkeob);
ftkoob=fthoo.*Rbft;
koob=ifft2(ftkoob);

%necessary functions for a
nphia=-2*(keoa.*kooa+keea.*koea);
dphia=keea.^2-koea.^2+keoa.^2-kooa.^2;
nthetaa=-2*(koea.*kooa+keea.*keoa);
dthetaa=keea.^2+koea.^2-keoa.^2-kooa.^2;

%necessary functions for b
nphib=-2*(keob.*koob+keeb.*koeb);
dphib=keeb.^2-koeb.^2+keob.^2-koob.^2;
nthetab=-2*(koeb.*koob+keeb.*keob);
dthetab=keeb.^2+koeb.^2-keob.^2-koob.^2;

clear keea keeb keoa keob koea koeb kooa keeb;
clear ftkeea ftkeeb ftkeoa ftkeob ftkoea ftkoeb ftkooa ftkoob;
clear hee heo heo hoe hoo;
clear fthee ftheo fthoe fthoo;
clear Raft Rbft;

%phase components for a
phia=atan2(nphia,dphia)/2;
thetaa=atan2(nthetaa,dthetaa)/2;

%phase components for b
phib=atan2(nphib,dphib)/2;
thetab=atan2(nthetab,dthetab)/2;

%derivatives of phase components

dnphia=zeros(size(Ra));
ddphia=zeros(size(Ra));
dnthetaa=zeros(size(Ra));
ddthetaa=zeros(size(Ra));

dnphia(:,2:n-1)=(nphia(:,3:n)-nphia(:,1:n-2))/2;
ddphia(:,2:n-1)=(dphia(:,3:n)-dphia(:,1:n-2))/2;
ddthetaa(2:n-1,:)=(dthetaa(3:n,:)-dthetaa(1:n-2,:))/2;
dnthetaa(2:n-1,:)=(nthetaa(3:n,:)-nthetaa(1:n-2,:))/2;

dnphib=zeros(size(Rb));
ddphib=zeros(size(Rb));
dnthetab=zeros(size(Rb));
ddthetab=zeros(size(Rb));

dnphib(:,2:n-1)=(nphib(:,3:n)-nphib(:,1:n-2))/2;
ddphib(:,2:n-1)=(dphib(:,3:n)-dphib(:,1:n-2))/2;
ddthetab(2:n-1,:)=(dthetab(3:n,:)-dthetab(1:n-2,:))/2;
dnthetab(2:n-1,:)=(nthetab(3:n,:)-nthetab(1:n-2,:))/2;

for i=2:size(Ra)-1
    dnphia(i,:)=dnphia(i,:)+(nphia(i+1,:)-nphia(i-1,:))/2;
    ddphia(i,:)=ddphia(i,:)+(dphia(i+1,:)-dphia(i-1,:))/2;
    ddthetaa(:,i)=ddthetaa(:,i)+(dthetaa(:,i+1)-dthetaa(:,i-1))/2;
    dnthetaa(:,i)=dnthetaa(:,i)+(nthetaa(:,i+1)-nthetaa(:,i-1))/2;
end
dxphia=0*dnphia;
dythetaa=0*dnthetaa;

ha=find(nphia.^2+dphia.^2 > eps1);
hb=find(nthetaa.^2+dthetaa.^2 > eps1);

dxphia(ha)=((dphia(ha).*dnphia(ha))-(nphia(ha).*ddphia(ha)))./(nphia(ha).^2+ ...
                                                  dphia(ha).^2);

dythetaa(hb)=((dthetaa(hb).*dnthetaa(hb))-(nthetaa(hb).*ddthetaa(hb)))./(nthetaa(hb).^2+dthetaa(hb).^2);
  

dxphib=0*dnphib;
dythetab=0*dnthetab;

hc=find(nphib.^2+dphib.^2 > eps1);
hd=find(nthetab.^2+dthetab.^2 > eps1);

dxphib(hc)=((dphib(hc).*dnphib(hc))-(nphib(hc).*ddphib(hc)))./(nphib(hc).^2+ ...
                                                  dphib(hc).^2);

dythetab(hd)=((dthetab(hd).*dnthetab(hd))-(nthetab(hd).*ddthetab(hd)))./(nthetab(hd).^2+dthetab(hd).^2);



%disparities
dx=0*Ra;
dy=0*Ra;
h1=find(abs(dxphia) > eps1);
h2=find(abs(dythetaa) > eps1);
dx(h1)=(phib(h1)-phia(h1))./(dxphia(h1));
dy(h2)=(thetab(h2)-thetaa(h2))./(dythetaa(h2));

dxs=fftshift(dx);
dys=fftshift(dy);

dx2=0*Ra;
dy2=0*Ra;
h3=find(abs(dxphib) > eps1);
h4=find(abs(dythetab) > eps1);
dx2(h3)=(phia(h3)-phib(h3))./(dxphib(h3));
dy2(h4)=(thetaa(h4)-thetab(h4))./(dythetab(h4));

dx2s=fftshift(dx2);
dy2s=fftshift(dy2);

clear h1 h2 h3 h4 ha hb hc hd;



dxn=(dxs-dx2s)/2;
dyn=(dys-dy2s)/2;

magf=sqrt(dxs.^2+dys.^2);
mag=sqrt(dxn.^2+dyn.^2);

figure;
subplot(4,4,6)
imagesc(Ra(80:115,70:105));
colormap(1-gray)
axis equal tight;
%axis off;
subplot(4,4,7)
imagesc(Rb(80:115,70:105));
colormap(1-gray)
axis equal tight;
%axis off;
subplot(4,4,10);
imagesc(mag(80:115,70:105));
colormap(1-gray);
axis equal tight;
%axis off;
subplot(4,4,11)
quiver(1:36,1:36,dxn(80:115,70:105),dyn(80:115,70:105),1.5);
axis ij;
axis equal tight;

