function y = axis(x)
% Axis of quaternion.
% If Q = A + mu .* B where A and B are real/complex, and mu is a unit pure
% quaternion, then axis(Q) = mu.

% Copyright  2005 Stephen J. Sangwine and Nicolas Le Bihan.
% See the file : Copyright.m for further details.

error(nargchk(1, 1, nargin)), error(nargoutchk(0, 1, nargout)) 

% Algorithm: take the vector part of the quaternion x, and then make
% a unit pure quaternion from it by dividing by the modulus.   Since
% the vector part could be complex, the warning check below has to
% use abs twice to get a real result.

V = v(x);

if any(abs(abs(V)) < eps)
    warning('At least one element may have an undefined axis.');
end

y = unit(V);
