function d = double(q)
% DOUBLE Convert quaternion to double precision.
% (Quaternion overloading of standard Matlab function.)
%
% This function converts a quaternion array into a quaternion array with
% components represented in double precision.

% Copyright  2005 Stephen J. Sangwine and Nicolas Le Bihan.
% See the file : Copyright.m for further details.

error(nargchk(1, 1, nargin)), error(nargoutchk(0, 1, nargout)) 

if ispure(q)
    d = quaternion(              double(x(q)), double(y(q)), double(z(q)));
else
    d = quaternion(double(s(q)), double(x(q)), double(y(q)), double(z(q)));
end
