function d = int16(q)
% INT16 Convert to signed 16-bit integer.
% (Quaternion overloading of standard Matlab function.)
%
% This function converts a quaternion array into a quaternion array with
% components represented as 16-bit signed integers.

% Copyright  2005 Stephen J. Sangwine and Nicolas Le Bihan.
% See the file : Copyright.m for further details.

error(nargchk(1, 1, nargin)), error(nargoutchk(0, 1, nargout)) 

if ispure(q)
    d = quaternion(             int16(x(q)), int16(y(q)), int16(z(q)));
else
    d = quaternion(int16(s(q)), int16(x(q)), int16(y(q)), int16(z(q)));
end
