function d = int8(q)
% INT8 Convert to signed 8-bit integer.
% (Quaternion overloading of standard Matlab function.)
%
% This function converts a quaternion array into a quaternion array with
% components represented as 8-bit signed integers.

% Copyright  2005 Stephen J. Sangwine and Nicolas Le Bihan.
% See the file : Copyright.m for further details.

error(nargchk(1, 1, nargin)), error(nargoutchk(0, 1, nargout)) 

if ispure(q)
    d = quaternion(            int8(x(q)), int8(y(q)), int8(z(q)));
else
    d = quaternion(int8(s(q)), int8(x(q)), int8(y(q)), int8(z(q)));
end
