function Z = power(X, Y)
% .^   Array power.
% (Quaternion overloading of standard Matlab function.)

% Copyright  2005 Stephen J. Sangwine and Nicolas Le Bihan.
% See the file : Copyright.m for further details.

error(nargchk(2, 2, nargin)), error(nargoutchk(0, 1, nargout)) 

% This function is quite complex to implement for the case of
% fractional powers, since it requires logarithms. For the
% moment, only an integer power of 2 is supported.

if size(Y) ~= [1, 1]
    error('Quaternion power is not implemented for non-scalar powers.');
else
    % Y is a scalar. We can handle one case at the moment.
    if Y == 2
        Z = X .* X;
    else
        error('Quaternion .^ is implemented for exponent of 2 only.')
    end
end
