function d = uint32(q)
% UINT32 Convert to unsigned 32-bit integer.
% (Quaternion overloading of standard Matlab function.)
%
% This function converts a quaternion array into a quaternion array with
% components represented as 32-bit unsigned integers.

% Copyright  2005 Stephen J. Sangwine and Nicolas Le Bihan.
% See the file : Copyright.m for further details.

error(nargchk(1, 1, nargin)), error(nargoutchk(0, 1, nargout)) 

if ispure(q)
    d = quaternion(              uint32(x(q)), uint32(y(q)), uint32(z(q)));
else
    d = quaternion(uint32(s(q)), uint32(x(q)), uint32(y(q)), uint32(z(q)));
end
