function d = uint8(q)
% UINT8 Convert to unsigned 8-bit integer.
% (Quaternion overloading of standard Matlab function.)
%
% This function converts a quaternion array into a quaternion array with
% components represented as 8-bit unsigned integers.

% Copyright  2005 Stephen J. Sangwine and Nicolas Le Bihan.
% See the file : Copyright.m for further details.

error(nargchk(1, 1, nargin)), error(nargoutchk(0, 1, nargout)) 

if ispure(q)
    d = quaternion(             uint8(x(q)), uint8(y(q)), uint8(z(q)));
else
    d = quaternion(uint8(s(q)), uint8(x(q)), uint8(y(q)), uint8(z(q)));
end
