function r = unit(a)
% UNIT quaternion. Divides a quaternion by its own modulus.

% Copyright  2005 Stephen J. Sangwine and Nicolas Le Bihan.
% See the file : Copyright.m for further details.

error(nargchk(1, 1, nargin)), error(nargoutchk(0, 1, nargout)) 

m = abs(a);

% Since m could be complex, the warning check below has to
% use abs again to get a real result for comparison with eps.

if any(abs(m) < eps)
    warning('At least one element has zero modulus, and divide by zero will occur.');
end

r = a ./ m;
