function d = int32(q)
% INT32 Convert to signed 32-bit integer.
% (Quaternion overloading of standard Matlab function.)
%
% This function converts a quaternion array into a quaternion array with
% components represented as 32-bit signed integers.

% Copyright  2005 Stephen J. Sangwine and Nicolas Le Bihan.
% See the file : Copyright.m for further details.

error(nargchk(1, 1, nargin)), error(nargoutchk(0, 1, nargout)) 

if ispure(q)
    d = quaternion(             int32(x(q)), int32(y(q)), int32(z(q)));
else
    d = quaternion(int32(s(q)), int32(x(q)), int32(y(q)), int32(z(q)));
end
