function d = single(q)
% SINGLE Convert quaternion to single precision.
% (Quaternion overloading of standard Matlab function.)
%
% This function converts a quaternion array into a quaternion array with
% components represented in single precision.

% Copyright  2005 Stephen J. Sangwine and Nicolas Le Bihan.
% See the file : Copyright.m for further details.

error(nargchk(1, 1, nargin)), error(nargoutchk(0, 1, nargout)) 

if ispure(q)
    d = quaternion(              single(x(q)), single(y(q)), single(z(q)));
else
    d = quaternion(single(s(q)), single(x(q)), single(y(q)), single(z(q)));
end
