function d = uint16(q)
% UINT16 Convert to unsigned 16-bit integer.
% (Quaternion overloading of standard Matlab function.)
%
% This function converts a quaternion array into a quaternion array with
% components represented as 16-bit unsigned integers.

% Copyright  2005 Stephen J. Sangwine and Nicolas Le Bihan.
% See the file : Copyright.m for further details.

error(nargchk(1, 1, nargin)), error(nargoutchk(0, 1, nargout)) 

if ispure(q)
    d = quaternion(              uint16(x(q)), uint16(y(q)), uint16(z(q)));
else
    d = quaternion(uint16(s(q)), uint16(x(q)), uint16(y(q)), uint16(z(q)));
end
